## 开发环境

* linux
* git
* python3
* navida GPU
* bazel  编译工具

源码编译：

```
sudo apt-get update && sudo apt-get install bazel
git clone --recurse-submodules https://github.com/tensorflow/tensorflow
cd tensorflow
./configure

# 有 GPU 支持： 
bazel build -c opt --config=cuda //tensorflow/tools/pip_package:build_pip_package 
```

解析：

./configure 其实执行的是 configure.py，配置所有编译的环境变量。

1、解析命令行所有传入参数：

```
  parser = argparse.ArgumentParser()
  parser.add_argument(
      '--workspace',
      type=str,
      default=os.path.abspath(os.path.dirname(__file__)),
      help='The absolute path to your active Bazel workspace.')
```

2、判断是windows，linux平台，不同平台使用不同环境编译，比如：

```
def is_linux():
  return platform.system() == 'Linux'

```


3、bazel build 编译源码

bazel是google内部的构建工具，

解析 WORKSPACE 每个一 BUILD 文件，分布式编译。

```

```


## 源码结构

基于 master a1a7af994db7e5891ab4294c0a678cf7ff1632cd commit (2020年主分支代码)分析，

tensorflow 

```
tensorflow\tensorflow        源码
    tensorflow\tensorflow\c
    tensorflow\tensorflow\cc   C++接口
    tensorflow\tensorflow\compiler    核心代码，30MB
    tensorflow\tensorflow\core        核心源码，47MB
        tensorflow\tensorflow\core\api_def
        tensorflow\tensorflow\core\common_runtime    本地runtime
        tensorflow\tensorflow\core\data
        tensorflow\tensorflow\core\debug
        tensorflow\tensorflow\core\distributed_runtime  分布式runtime
        tensorflow\tensorflow\core\example
        tensorflow\tensorflow\core\framework            框架层
        tensorflow\tensorflow\core\graph                图
        tensorflow\tensorflow\core\grappler
        tensorflow\tensorflow\core\kernels            
        tensorflow\tensorflow\core\lib
        tensorflow\tensorflow\core\nccl
        tensorflow\tensorflow\core\ops      op算子
        tensorflow\tensorflow\core\platform
        tensorflow\tensorflow\core\profiler
        tensorflow\tensorflow\core\protobuf        数据格式交换
        tensorflow\tensorflow\core\public
        tensorflow\tensorflow\core\summary
        tensorflow\tensorflow\core\tpu
        tensorflow\tensorflow\core\user_ops          自定义算子
        tensorflow\tensorflow\core\util
    tensorflow\tensorflow\docs_src
    tensorflow\tensorflow\examples
    tensorflow\tensorflow\g3doc
    tensorflow\tensorflow\go
    tensorflow\tensorflow\java        java接口
    tensorflow\tensorflow\js          js接口
    tensorflow\tensorflow\lite
    tensorflow\tensorflow\python         python接口，接口最全
    tensorflow\tensorflow\security
    tensorflow\tensorflow\stream_executor        cuda和opencl封装，统一调用
    tensorflow\tensorflow\tools
tensorflow\third_party       第三方源码
tensorflow\tools             开发工具
```


* 多语言扩展

swig包装器，帮助使用C或者C++编写的软件能与其它各种高级编程语言进行嵌入联接的开发工具。swig包装器生成两个wrapper文件

```
pywrap_tensorflow_internal.py：对接上层Python调用
pywrap_tensorflow_internal.cc：对接底层C API调用。
```
pywrap_tensorflow_internal.py 模块被导入时，会加载_pywrap_tensorflow_internal.so动态链接库，它里面包含了所有运行时接口的符号。而pywrap_tensorflow_internal.cc中，则注册了一个函数符号表，实现Python接口和C接口的映射。运行时，就可以通过映射表，找到Python接口在C层的实现了。





